function c=xgausscurvature(x,y,z)
% adapted from 
% http://www.mathworks.com/matlabcentral/fileexchange/loadFile.do?objectId=5229&objectType=file
%
% computes gaussian curvature for surf(x,y,z)
%

[xu ,xv ]=gradient(x );
[yu ,yv ]=gradient(y );
[zu ,zv ]=gradient(z );
[xuu,xuv]=gradient(xu);
[yuu,yuv]=gradient(yu);
[zuu,zuv]=gradient(zu);
[xvu,xvv]=gradient(xv);
[yvu,yvv]=gradient(yv);
[zvu,zvv]=gradient(zv);

E=xu.*xu+yu.*yu+zu.*zu;
F=xu.*xv+yu.*yv+zu.*zv;
G=xv.*xv+yv.*yv+zv.*zv;

[Nx,Ny,Nz]=surfnorm(x,y,z);

L=xuu.*Nx+yuu.*Ny+zuu.*Nz;
M=xuv.*Nx+yuv.*Ny+zuv.*Nz;
N=xvv.*Nx+yvv.*Ny+zvv.*Nz;

c=(L.*N-M.*M)./(E.*G-F.*F);
